<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui"><title>JavaScript: Funkce</title><meta name="author" content="Ing. Jan Kolomazník, Ph.D. &lt;jan.kolomaznik@gmail.com&gt;"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/reset.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/reveal.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/theme/serif.css" id="theme"><!--This CSS is generated by the Asciidoctor reveal.js converter to further integrate AsciiDoc's existing semantic with reveal.js--><style type="text/css">.reveal div.right{float:right}

/* listing block */
.reveal .listingblock.stretch>.content{height: 100%}
.reveal .listingblock.stretch>.content>pre{height: 100%}
.reveal .listingblock.stretch>.content>pre>code{height:100%;max-height:100%}

/* tables */
table{border-collapse:collapse;border-spacing:0}
table{margin-bottom:1.25em;border:solid 1px #dedede}
table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;text-align:left}
table tr th,table tr td{padding:.5625em .625em;font-size:inherit}
table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{display:table-cell;line-height:1.6}
td.tableblock>.content{margin-bottom:1.25em}
td.tableblock>.content>:last-child{margin-bottom:-1.25em}
table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
table.grid-all>thead>tr>.tableblock,table.grid-all>tbody>tr>.tableblock{border-width:0 1px 1px 0}
table.grid-all>tfoot>tr>.tableblock{border-width:1px 1px 0 0}
table.grid-cols>*>tr>.tableblock{border-width:0 1px 0 0}
table.grid-rows>thead>tr>.tableblock,table.grid-rows>tbody>tr>.tableblock{border-width:0 0 1px}
table.grid-rows>tfoot>tr>.tableblock{border-width:1px 0 0}
table.grid-all>*>tr>.tableblock:last-child,table.grid-cols>*>tr>.tableblock:last-child{border-right-width:0}
table.grid-all>tbody>tr:last-child>.tableblock,table.grid-all>thead:last-child>tr>.tableblock,table.grid-rows>tbody>tr:last-child>.tableblock,table.grid-rows>thead:last-child>tr>.tableblock{border-bottom-width:0}
table.frame-all{border-width:1px}
table.frame-sides{border-width:0 1px}
table.frame-topbot,table.frame-ends{border-width:1px 0}
.reveal table th.halign-left,.reveal table td.halign-left{text-align:left}
.reveal table th.halign-right,.reveal table td.halign-right{text-align:right}
.reveal table th.halign-center,.reveal table td.halign-center{text-align:center}
.reveal table th.valign-top,.reveal table td.valign-top{vertical-align:top}
.reveal table th.valign-bottom,.reveal table td.valign-bottom{vertical-align:bottom}
.reveal table th.valign-middle,.reveal table td.valign-middle{vertical-align:middle}
table thead th,table tfoot th{font-weight:bold}
tbody tr th{display:table-cell;line-height:1.6}
tbody tr th,tbody tr th p,tfoot tr th,tfoot tr th p{font-weight:bold}
thead{display:table-header-group}

.reveal table.grid-none th,.reveal table.grid-none td{border-bottom:0!important}

/* kbd macro */
kbd{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;display:inline-block;color:rgba(0,0,0,.8);font-size:.65em;line-height:1.45;background:#f7f7f7;border:1px solid #ccc;-webkit-border-radius:3px;border-radius:3px;-webkit-box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em white inset;box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em #fff inset;margin:0 .15em;padding:.2em .5em;vertical-align:middle;position:relative;top:-.1em;white-space:nowrap}
.keyseq kbd:first-child{margin-left:0}
.keyseq kbd:last-child{margin-right:0}

/* callouts */
.conum[data-value] {display:inline-block;color:#fff!important;background:rgba(0,0,0,.8);-webkit-border-radius:50%;border-radius:50%;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]:after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}
/* Callout list */
.hdlist>table,.colist>table{border:0;background:none}
.hdlist>table>tbody>tr,.colist>table>tbody>tr{background:none}
td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
td.hdlist1{font-weight:bold;padding-bottom:1.25em}
/* Disabled from Asciidoctor CSS because it caused callout list to go under the
 * source listing when .stretch is applied (see #335)
 * .literalblock+.colist,.listingblock+.colist{margin-top:-.5em} */
.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
.colist td:not([class]):first-child img{max-width:none}
.colist td:not([class]):last-child{padding:.25em 0}

/* Override Asciidoctor CSS that causes issues with reveal.js features */
.reveal .hljs table{border: 0}
/* Callout list rows would have a bottom border with some reveal.js themes (see #335) */
.reveal .colist>table th, .reveal .colist>table td {border-bottom:0}
/* Fixes line height with Highlight.js source listing when linenums enabled (see #331) */
.reveal .hljs table thead tr th, .reveal .hljs table tfoot tr th, .reveal .hljs table tbody tr td, .reveal .hljs table tr td, .reveal .hljs table tfoot tr td{line-height:inherit}

/* Columns layout */
.columns .slide-content {
  display: flex;
}

.columns.wrap .slide-content {
  flex-wrap: wrap;
}

.columns.is-vcentered .slide-content {
  align-items: center;
}

.columns .slide-content > .column {
  display: block;
  flex-basis: 0;
  flex-grow: 1;
  flex-shrink: 1;
  padding: .75rem;
}

.columns .slide-content > .column.is-full {
  flex: none;
  width: 100%;
}

.columns .slide-content > .column.is-four-fifths {
  flex: none;
  width: 80%;
}

.columns .slide-content > .column.is-three-quarters {
  flex: none;
  width: 75%;
}

.columns .slide-content > .column.is-two-thirds {
  flex: none;
  width: 66.6666%;
}

.columns .slide-content > .column.is-three-fifths {
  flex: none;
  width: 60%;
}

.columns .slide-content > .column.is-half {
  flex: none;
  width: 50%;
}

.columns .slide-content > .column.is-two-fifths {
  flex: none;
  width: 40%;
}

.columns .slide-content > .column.is-one-third {
  flex: none;
  width: 33.3333%;
}

.columns .slide-content > .column.is-one-quarter {
  flex: none;
  width: 25%;
}

.columns .slide-content > .column.is-one-fifth {
  flex: none;
  width: 20%;
}
</style><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0-1/css/all.min.css"><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0-1/css/v4-shims.min.css"><!--Printing and PDF exports--><script>var link = document.createElement( 'link' );
link.rel = 'stylesheet';
link.type = 'text/css';
link.href = window.location.search.match( /print-pdf/gi ) ? "https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/print/pdf.css" : "https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/print/paper.css";
document.getElementsByTagName( 'head' )[0].appendChild( link );</script></head><body><div class="reveal"><div class="slides"><section class="title" data-state="title"><h1>JavaScript</h1><h2>Funkce</h2><div class="preamble"><div class="paragraph"><p><a href="https://eloquentjavascript.net/03_functions.html" class="bare">https://eloquentjavascript.net/03_functions.html</a></p></div></div><p class="author"><small>Ing. Jan Kolomazník, Ph.D. &lt;jan.kolomaznik@gmail.com&gt;</small></p></section>
<section id="_motivace"><h2>Motivace</h2><div class="slide-content"><div class="paragraph"><p>Funkce umožňují rozdělit aplikaci do pojmenovacích jednotek a ty opakovaně používat.</p></div>
<div class="ulist"><ul><li><p>Mnoho funkcí je přímo součástí JavaScriptu</p></li><li><p>Další funkce jsou součástí prohlížeče nebo NodeJS</p></li><li><p>Ale nejvíce funkcí je dostupných přes <strong>npm</strong></p></li><li><p>V JavaScriptu můžeme funkce vytvářet vlastní funkce a to hned několika způsoby.</p></li></ul></div></div></section>
<section><section id="_definice"><h2>Definice</h2><div class="slide-content"><div class="paragraph"><p>Vytvořme si funkci <code>square</code> vracející druhou mocninu</p></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">const square = function(x) {
 return x * x;
};

console.log(square(12));
// → 144</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Předchozí funkce má jeden parametr, funkce ale nemusí mít parametr žádný</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">const makeNoise = function() {
 console.log("Pling!");
};

makeNoise();
// → Pling!</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Nebo parametrů více, například 2</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">const power = function(base, exponent) {
 let result = 1;
 for (let count = 0; count &lt; exponent; count++) {
   result *= base;
 }
 return result;
};

console.log(power(2, 10));
// → 1024</code></pre></div></div></div></section><section id="_návratová_hodnota"><h2>Návratová hodnota</h2><div class="slide-content"><div class="paragraph"><p>Funkce může ale také nemusí nic vracet.</p></div>
<div class="ulist"><ul><li><p>Pokud ukončí tělo funkce, pak funkce vrací hodnotu <code>undefined</code></p><div class="ulist"><ul><li><p>Například naše funkce <code>makeNoise</code></p></li></ul></div></li><li><p>Klíčové slovo <code>return</code> ukončuje funkci</p><div class="ulist"><ul><li><p>V takovém případě také vrací <code>undefined</code></p></li></ul></div></li><li><p><code>return proměnná;</code> pak vrací hodnotu proměnné z funkce</p><div class="ulist"><ul><li><p>Příkladem je naše funkce <code>power</code></p></li></ul></div></li></ul></div></div></section></section>
<section><section id="_scope_viditelnost_proměnných"><h2>Scope: viditelnost proměnných</h2><div class="slide-content"><div class="paragraph"><p>Scope určuje rozsah v rámci které je proměnná/funkce viditelná</p></div><div class="ulist"><ul><li><p>Viditelnost proměnných je určena funkci/blokem kde jsou deklarované pomocí <code>let</code> a <code>const</code></p></li></ul></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let x = 10;
if (true) {
 let y = 20;
 console.log(x + y);
 // → 30
}
// y is not visible here
console.log(x);
// → 10</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Výjimkou je <code>var</code> v tom případě je proměnná jakoby deklarována v nadřazeném scope.</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let x = 10;
if (true) {
 let y = 20;
 var z = 30;
 console.log(x + y + z);
 // → 60
}
// y is not visible here
console.log(x + z);
// → 40</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Pokud jsou proměnné použití vícenásobně pak jsou izolované a pracuje vždy s tou nejblíže definovanou.</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">const halve = function(n) {
 return n / 2;
};

let n = 10;
console.log(halve(100));
// → 50
console.log(n);
// → 10</code></pre></div></div></div></section><section id="_nested_scope"><h2>Nested scope</h2><div class="slide-content"><div class="paragraph"><p>V JavaScriptu můžete definovat funkce uvnitř jiných funkcí, v takovém případě se proměnné přenášejí</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">const hummus = function(factor) {
 const ingredient = function(amount, unit, name) {
   let ingredientAmount = amount * factor;
   if (ingredientAmount &gt; 1) {
     unit += "s";
   }
   console.log(`${ingredientAmount} ${unit} ${name}`);
 };
 ingredient(1, "can", "chickpeas");
 ingredient(0.25, "cup", "tahini");
 ingredient(0.25, "cup", "lemon juice");
 ingredient(1, "clove", "garlic");
 ingredient(2, "tablespoon", "olive oil");
 ingredient(0.5, "teaspoon", "cumin");
};</code></pre></div></div></div></section></section>
<section id="_funkce_jako_proměnné"><h2>Funkce jako proměnné</h2><div class="slide-content"><div class="paragraph"><p>Abychom mohli funkci použít, musíme ji přiřadit jméno, přes které ji voláme.</p></div>
<div class="ulist"><ul><li><p>Většinou chceme aby funkce byla pevně svázána s určitým jménem</p><div class="ulist"><ul><li><p>proto <code>const name = function() { &#8230;&#8203;.</code></p></li></ul></div></li><li><p>Můžem ale místo <code>const</code> použít <code>let</code></p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let launchMissiles = function() {
 missileSystem.launch("now");
};
if (safeMode) {
 launchMissiles = function() {/* do nothing */};
}</code></pre></div></div></div></section>
<section><section id="_deklarativní_notace"><h2>Deklarativní notace</h2><div class="slide-content"><div class="paragraph"><p>Funkci můžeme definovat i deklaratorním způsobem</p></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function square(x) {
 return x * x;
}</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Funkce může být použita až poté, co je definována</p></div>
<div class="ulist"><ul><li><p>Neexistuje žádný extra rozdíl mezi <em>arrow funkci</em> a <code>function</code></p><div class="ulist"><ul><li><p>OK existují mikro rozdíly, které probereme později.</p></li></ul></div></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log("The future says:", future());

function future() {
 return "You'll never have flying cars";
}</code></pre></div></div></div></section></section>
<section><section id="_arrow_funkce"><h2>Arrow funkce</h2><div class="slide-content"><div class="paragraph"><p>Existuje i třetí notace k definici funkce</p></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">const power = (base, exponent) =&gt; {
 let result = 1;
 for (let count = 0; count &lt; exponent; count++) {
   result *= base;
 }
 return result;
};</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p><em>Arrow funkce</em> jsou velmi flexibilní, co se zápisu týče</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">const square1 = (x) =&gt; { return x * x; };
const square2 = x =&gt; x * x;
const horn = () =&gt; {
 console.log("Toot");
};</code></pre></div></div></div></section></section>
<section id="_the_call_stack"><h2>The call stack</h2><div class="slide-content"><div class="paragraph"><p>Jak program prochází kódem volají se různé funkce, Javascript uchovává tuto historii volání, říkáme tomu <em>call stack</em>.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function chicken() {
 return egg();
}
function egg() {
 return chicken();
}
console.log(chicken() + " came first.");
// → ??</code></pre></div></div></div></section>
<section><section id="_volitelné_argumenty"><h2>Volitelné argumenty</h2><div class="slide-content"><div class="paragraph"><p>JavaScript se chová a argumentů funkcí <strong>velmi</strong> volně</p></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function square(x) { return x * x; }
console.log(square(4, true, "hedgehog"));
// → 16</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Toho se dá šikovně využít</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function minus(a, b) {
 if (b === undefined) return -a;
 else return a - b;
}

console.log(minus(10));
// → -10
console.log(minus(10, 5));
// → 5</code></pre></div></div></div></section><section id="_výchozí_hodnoty"><h2>Výchozí hodnoty</h2><div class="slide-content"><div class="paragraph"><p>U parametrů můžeme definovat výchozí hodnoty</p></div>
<div class="ulist"><ul><li><p>Vyhneme se tak kontrole hodnoty <code>undefined</code></p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function power(base, exponent = 2) {
 let result = 1;
 for (let count = 0; count &lt; exponent; count++) {
   result *= base;
 }
 return result;
}

console.log(power(4));
// → 16
console.log(power(2, 6));
// → 64</code></pre></div></div></div></section></section>
<section><section id="_closure"><h2>Closure</h2><div class="slide-content"><div class="paragraph"><p>V JavaScriptu můžeme definovat funkci v jiné funkci a takto definovanou funkci následně volat.</p></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function wrapValue(n) {
 let local = n;
 return () =&gt; local;
}

let wrap1 = wrapValue(1);
let wrap2 = wrapValue(2);
console.log(wrap1());
// → 1
console.log(wrap2());
// → 2</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Takto znovuvytvářené funce si nesou prostředí původní funkce</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function multiplier(factor) {
 return number =&gt; number * factor;
}

let twice = multiplier(2);
console.log(twice(5));
// → 10</code></pre></div></div></div></section></section>
<section><section id="_rekurze"><h2>Rekurze</h2><div class="slide-content"><div class="paragraph"><p>Rekurze tedy <strong>volání samo sebe</strong> je další důležitá vlastnost funkcí</p></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function power(base, exponent) {
 if (exponent == 0) {
   return 1;
 } else {
   return base * power(base, exponent - 1);
 }
}

console.log(power(2, 3));
// → 8</code></pre></div></div></div></section><section id="_elegance_vs_výkon"><h2>Elegance vs. výkon</h2><div class="slide-content"><div class="ulist"><ul><li><p>Při rekurzivní volání funkce se vy vytvářejí velmi hluboké <em>call stack_</em></p><div class="ulist"><ul><li><p>To může být náročné na prostředky</p></li></ul></div></li><li><p>Síla rekurzivní funkcí je v jednoduchosti zápisu</p><div class="ulist"><ul><li><p>Zvažte např definici <em>fibonacciho řady</em> (<code>fib(n) = fib(n-1)+fib(n-2)</code>)</p></li></ul></div></li><li><p>Nicméně rekurze se vždy dá přepsat na smyčky</p></li><li><p>Rekurze je velmi užitečná při prohledávání možnosti &#8230;&#8203;</p></li></ul></div></div></section><section id="_rekurze_příklad"><h2>Rekurze příklad</h2><div class="slide-content"><div class="quoteblock"><blockquote><div class="paragraph"><p>Začítáne od čísla 1.
K němu přičítáte číslo 5 nebo násobíte číslem 3.</p></div>
<div class="paragraph"><p>Takto se lze dopočítat k velkému množství čísel, např 13 = (((1*3)+5)+5)
Ne však ke všem (například 15).</p></div>
<div class="paragraph"><p>Vytvořte program, kterému zadáte číslo a on vytvoří rozvoj.</p></div></blockquote></div></div></section><section><div class="slide-content"><div class="listingblock"><div class="title">Řešení pomocí rekurze</div>
<div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function findSolution(target) {
 function find(current, history) {
   if (current == target) {
     return history;
   } else if (current &gt; target) {
     return null;
   } else {
     return find(current + 5, `(${history} + 5)`) ||
            find(current * 3, `(${history} * 3)`);
   }
 }
 return find(1, "1");
}</code></pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(findSolution(24));
// → (((1 * 3) + 5) * 3)</code></pre></div></div></div></section></section>
<section><section id="_vytváření_funkcí"><h2>Vytváření funkcí</h2><div class="slide-content"><div class="paragraph"><p>Při vytváření funkcí je nejobtížnější najít vhodné jméno a co mají funkce vlastně dělat.
Platí několik jednoduchých pravidel</p></div><div class="ulist"><ul><li><p>Jméno funkce by mělo vyjadřovat co funkce dělá</p></li><li><p>Funkce by měla dělat jednu věc</p></li><li><p>Funkce by měla usnadnit čtení programu a jeho pochopení</p></li></ul></div></div></section><section id="_příklad"><h2>Příklad</h2><div class="slide-content"><div class="paragraph"><p>Máte napsat program který vytiskne počet zvířat na farme</p></div>
<div class="listingblock"><div class="content"><pre>007 Cows
011 Chickens</pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function printFarmInventory(cows, chickens) {
 let cowString = String(cows);
 while (cowString.length &lt; 3) {
   cowString = "0" + cowString;
 }
 console.log(`${cowString} Cows`);
 let chickenString = String(chickens);
 while (chickenString.length &lt; 3) {
   chickenString = "0" + chickenString;
 }
 console.log(`${chickenString} Chickens`);
}</code></pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">printFarmInventory(7, 11);</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>V programu je vidět, že se určitá část opakuje, co ji dát do funkce?</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function printZeroPaddedWithLabel(number, label) {
 let numberString = String(number);
 while (numberString.length &lt; 3) {
   numberString = "0" + numberString;
 }
 console.log(`${numberString} ${label}`);
}</code></pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function printFarmInventory(cows, chickens, pigs) {
 printZeroPaddedWithLabel(cows, "Cows");
 printZeroPaddedWithLabel(chickens, "Chickens");
 printZeroPaddedWithLabel(pigs, "Pigs");
}</code></pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">printFarmInventory(7, 11, 3);</code></pre></div></div>
<div class="paragraph"><p>Vypadá to dobře?</p></div></div></section><section><div class="slide-content"><h3>že NE?</h3><div class="paragraph"><p>Funkce <code>printZeroPaddedWithLabel</code> je prostě divná</p></div>
<div class="ulist"><ul><li><p>Má strašně dlouhé jméno</p></li><li><p>Vlastně nedělá jednu věc ale tří: tiskne, upravuje číslo, přidává popisek</p></li><li><p>Není moc znovupoužitelná, nebo jen velmi omezené</p></li></ul></div>
<div class="paragraph"><p>Co si z těch tří vecí vybrat právě jednu!</p></div></div></section><section><div class="slide-content"><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function zeroPad(number, width = 3) {
 let string = String(number);
 while (string.length &lt; width) {
   string = "0" + string;
 }
 return string;
}</code></pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function printFarmInventory(cows, chickens, pigs) {
 console.log(`${zeroPad(cows)} Cows`);
 console.log(`${zeroPad(chickens)} Chickens`);
 console.log(`${zeroPad(pigs)} Pigs`);
}</code></pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">printFarmInventory(7, 16, 3);</code></pre></div></div>
<div class="paragraph"><p>V čem je to lepší?</p></div></div></section></section>
<section><section id="_summary"><h2>Summary</h2><div class="slide-content"><div class="paragraph"><p>Tato kapitola jsme se naučili psát vlastní funkce.</p></div><div class="ulist"><ul><li><p>Pokud je klíčové slovo <code>function</code> použito jako výraz, může vytvořit funkci a tu může přiřadit k proměnné.</p></li><li><p>Když se používá jako příkaz, pak funkci deklarujeme včetně vazby.</p></li><li><p>Třetím způsobem vytvoření funkce jsou <em>arrow funkce</em>.</p></li></ul></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">const f = function(a) {
 console.log(a + 2);
};</code></pre></div></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function g(a, b) {
 return a * b * 3.5;
}</code></pre></div></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let h = a =&gt; a % 3;</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Klíčovým aspektem porozumění funkcím je porozumění viditelnost proměnných.</p></div>
<div class="ulist"><ul><li><p>Každý blok vytvoří nový rozsah viditelnosti.</p></li><li><p>Parametry a vazby deklarované v daném rozsahu jsou lokální a nejsou zvenčí viditelné.</p></li><li><p>Vazby deklarované pomocí <code>var</code> se chovají odlišně - skončí v nejbližším rozsahu funkce nebo v globálním rozsahu.</p></li></ul></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Je užitečné rozdělit úkoly, které váš program provádí, na různé funkce.</p></div>
<div class="ulist"><ul><li><p>Už se nebudete muset tolik opakovat</p></li><li><p>funkce mohou pomoci zorganizovat program seskupením kódu</p></li><li><p>kousky, které dělají konkrétní věci, jsou lehce čitelné.</p></li></ul></div></div></section></section>
<section><section id="_cvičení"><h2>Cvičení</h2></section><section id="_minimum"><h2>Minimum</h2><div class="slide-content"><div class="ulist"><ul><li><p>Implementujte funkci <code>min</code> která bude vracet vždy menší číslo ze dvou argumentů</p></li></ul></div></div></section><section id="_rekurze_2"><h2>Rekurze</h2><div class="slide-content"><div class="ulist"><ul><li><p>Vytvořte funkci, která vypíše prvních <strong>n</strong> členů fibonacciho posloupnosti.</p></li><li><p>Pro n = 6: <code>1, 1, 2, 3, 5, 8</code></p></li></ul></div></div></section><section id="_počítání_písmen"><h2>Počítání písmen</h2><div class="slide-content"><div class="ulist"><ul><li><p>Pro implementaci této úlohy potřebuje zníte dvě věci:</p><div class="olist arabic"><ol class="arabic"><li><p><code>string.length</code> vrací počet znaků v řetězci</p></li><li><p><code>string[n]</code> vrátí n-tý znak, první znak má index <code>n = 0</code>, poslední <code>n = string.length - 1</code></p></li></ol></div></li><li><p>Nejprve vytvořte funkci <code>countBs</code>, která spočítá všechna velká "B" v řetězci.</p></li><li><p>Poté vytvořte funkci <code>countChar</code>, která spočítá zadaný znak v řetězci.</p></li></ul></div></div></section><section><div class="slide-content"><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(countBs("BBC"));
// → 2
console.log(countChar("kakkerlak", "k"));
// → 4</code></pre></div></div></div></section></section></div></div><script src="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/js/reveal.js"></script><script>Array.prototype.slice.call(document.querySelectorAll('.slides section')).forEach(function(slide) {
  if (slide.getAttribute('data-background-color')) return;
  // user needs to explicitly say he wants CSS color to override otherwise we might break custom css or theme (#226)
  if (!(slide.classList.contains('canvas') || slide.classList.contains('background'))) return;
  var bgColor = getComputedStyle(slide).backgroundColor;
  if (bgColor !== 'rgba(0, 0, 0, 0)' && bgColor !== 'transparent') {
    slide.setAttribute('data-background-color', bgColor);
    slide.style.backgroundColor = 'transparent';
  }
});

// More info about config & dependencies:
// - https://github.com/hakimel/reveal.js#configuration
// - https://github.com/hakimel/reveal.js#dependencies
Reveal.initialize({
  // Display presentation control arrows
  controls: true,
  // Help the user learn the controls by providing hints, for example by
  // bouncing the down arrow when they first encounter a vertical slide
  controlsTutorial: true,
  // Determines where controls appear, "edges" or "bottom-right"
  controlsLayout: 'bottom-right',
  // Visibility rule for backwards navigation arrows; "faded", "hidden"
  // or "visible"
  controlsBackArrows: 'faded',
  // Display a presentation progress bar
  progress: true,
  // Display the page number of the current slide
  slideNumber: false,
  // Control which views the slide number displays on
  showSlideNumber: 'all',
  // Add the current slide number to the URL hash so that reloading the
  // page/copying the URL will return you to the same slide
  hash: false,
  // Push each slide change to the browser history. Implies `hash: true`
  history: false,
  // Enable keyboard shortcuts for navigation
  keyboard: true,
  // Enable the slide overview mode
  overview: true,
  // Vertical centering of slides
  center: false,
  // Enables touch navigation on devices with touch input
  touch: true,
  // Loop the presentation
  loop: false,
  // Change the presentation direction to be RTL
  rtl: false,
  // See https://github.com/hakimel/reveal.js/#navigation-mode
  navigationMode: 'default',
  // Randomizes the order of slides each time the presentation loads
  shuffle: false,
  // Turns fragments on and off globally
  fragments: true,
  // Flags whether to include the current fragment in the URL,
  // so that reloading brings you to the same fragment position
  fragmentInURL: false,
  // Flags if the presentation is running in an embedded mode,
  // i.e. contained within a limited portion of the screen
  embedded: false,
  // Flags if we should show a help overlay when the questionmark
  // key is pressed
  help: true,
  // Flags if speaker notes should be visible to all viewers
  showNotes: false,
  // Global override for autolaying embedded media (video/audio/iframe)
  // - null: Media will only autoplay if data-autoplay is present
  // - true: All media will autoplay, regardless of individual setting
  // - false: No media will autoplay, regardless of individual setting
  autoPlayMedia: null,
  // Global override for preloading lazy-loaded iframes
  // - null: Iframes with data-src AND data-preload will be loaded when within
  //   the viewDistance, iframes with only data-src will be loaded when visible
  // - true: All iframes with data-src will be loaded when within the viewDistance
  // - false: All iframes with data-src will be loaded only when visible
  preloadIframes: null,
  // Number of milliseconds between automatically proceeding to the
  // next slide, disabled when set to 0, this value can be overwritten
  // by using a data-autoslide attribute on your slides
  autoSlide: 0,
  // Stop auto-sliding after user input
  autoSlideStoppable: true,
  // Use this method for navigation when auto-sliding
  autoSlideMethod: Reveal.navigateNext,
  // Specify the average time in seconds that you think you will spend
  // presenting each slide. This is used to show a pacing timer in the
  // speaker view
  defaultTiming: 120,
  // Specify the total time in seconds that is available to
  // present.  If this is set to a nonzero value, the pacing
  // timer will work out the time available for each slide,
  // instead of using the defaultTiming value
  totalTime: 0,
  // Specify the minimum amount of time you want to allot to
  // each slide, if using the totalTime calculation method.  If
  // the automated time allocation causes slide pacing to fall
  // below this threshold, then you will see an alert in the
  // speaker notes window
  minimumTimePerSlide: 0,
  // Enable slide navigation via mouse wheel
  mouseWheel: false,
  // Hide cursor if inactive
  hideInactiveCursor: true,
  // Time before the cursor is hidden (in ms)
  hideCursorTime: 5000,
  // Hides the address bar on mobile devices
  hideAddressBar: true,
  // Opens links in an iframe preview overlay
  // Add `data-preview-link` and `data-preview-link="false"` to customise each link
  // individually
  previewLinks: false,
  // Transition style (e.g., none, fade, slide, convex, concave, zoom)
  transition: 'slide',
  // Transition speed (e.g., default, fast, slow)
  transitionSpeed: 'default',
  // Transition style for full page slide backgrounds (e.g., none, fade, slide, convex, concave, zoom)
  backgroundTransition: 'fade',
  // Number of slides away from the current that are visible
  viewDistance: 3,
  // Number of slides away from the current that are visible on mobile
  // devices. It is advisable to set this to a lower number than
  // viewDistance in order to save resources.
  mobileViewDistance: 3,
  // Parallax background image (e.g., "'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg'")
  parallaxBackgroundImage: '',
  // Parallax background size in CSS syntax (e.g., "2100px 900px")
  parallaxBackgroundSize: '',
  // Number of pixels to move the parallax background per slide
  // - Calculated automatically unless specified
  // - Set to 0 to disable movement along an axis
  parallaxBackgroundHorizontal: null,
  parallaxBackgroundVertical: null,
  // The display mode that will be used to show slides
  display: 'block',

  // The "normal" size of the presentation, aspect ratio will be preserved
  // when the presentation is scaled to fit different resolutions. Can be
  // specified using percentage units.
  width: 1250,
  height: 700,

  // Factor of the display size that should remain empty around the content
  margin: 0.1,

  // Bounds for smallest/largest possible scale to apply to content
  minScale: 0.2,
  maxScale: 1.5,

  // PDF Export Options
  // Put each fragment on a separate page
  pdfSeparateFragments: true,
  // For slides that do not fit on a page, max number of pages
  pdfMaxPagesPerSlide: 1,

  // Optional libraries used to extend on reveal.js
  dependencies: [
      { src: 'https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/plugin/zoom-js/zoom.js', async: true },
      { src: 'https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/plugin/notes/notes.js', async: true }
  ],

  

});</script><script>var dom = {};
dom.slides = document.querySelector('.reveal .slides');

function getRemainingHeight(element, slideElement, height) {
  height = height || 0;
  if (element) {
    var newHeight, oldHeight = element.style.height;
    // Change the .stretch element height to 0 in order find the height of all
    // the other elements
    element.style.height = '0px';
    // In Overview mode, the parent (.slide) height is set of 700px.
    // Restore it temporarily to its natural height.
    slideElement.style.height = 'auto';
    newHeight = height - slideElement.offsetHeight;
    // Restore the old height, just in case
    element.style.height = oldHeight + 'px';
    // Clear the parent (.slide) height. .removeProperty works in IE9+
    slideElement.style.removeProperty('height');
    return newHeight;
  }
  return height;
}

function layoutSlideContents(width, height) {
  // Handle sizing of elements with the 'stretch' class
  toArray(dom.slides.querySelectorAll('section .stretch')).forEach(function (element) {
    // Determine how much vertical space we can use
    var limit = 5; // hard limit
    var parent = element.parentNode;
    while (parent.nodeName !== 'SECTION' && limit > 0) {
      parent = parent.parentNode;
      limit--;
    }
    if (limit === 0) {
      // unable to find parent, aborting!
      return;
    }
    var remainingHeight = getRemainingHeight(element, parent, height);
    // Consider the aspect ratio of media elements
    if (/(img|video)/gi.test(element.nodeName)) {
      var nw = element.naturalWidth || element.videoWidth, nh = element.naturalHeight || element.videoHeight;
      var es = Math.min(width / nw, remainingHeight / nh);
      element.style.width = (nw * es) + 'px';
      element.style.height = (nh * es) + 'px';
    } else {
      element.style.width = width + 'px';
      element.style.height = remainingHeight + 'px';
    }
  });
}

function toArray(o) {
  return Array.prototype.slice.call(o);
}

Reveal.addEventListener('slidechanged', function () {
  layoutSlideContents(1250, 700)
});
Reveal.addEventListener('ready', function () {
  layoutSlideContents(1250, 700)
});
Reveal.addEventListener('resize', function () {
  layoutSlideContents(1250, 700)
});</script><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/lib/css/monokai.css"/>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/highlight.min.js"></script>

<script>

/* highlightjs-line-numbers.js 2.6.0 | (C) 2018 Yauheni Pakala | MIT License | github.com/wcoder/highlightjs-line-numbers.js */
/* Edited by Hakim for reveal.js; removed async timeout */
!function(n,e){"use strict";function t(){var n=e.createElement("style");n.type="text/css",n.innerHTML=g(".{0}{border-collapse:collapse}.{0} td{padding:0}.{1}:before{content:attr({2})}",[v,L,b]),e.getElementsByTagName("head")[0].appendChild(n)}function r(t){"interactive"===e.readyState||"complete"===e.readyState?i(t):n.addEventListener("DOMContentLoaded",function(){i(t)})}function i(t){try{var r=e.querySelectorAll("code.hljs,code.nohighlight");for(var i in r)r.hasOwnProperty(i)&&l(r[i],t)}catch(o){n.console.error("LineNumbers error: ",o)}}function l(n,e){"object"==typeof n&&f(function(){n.innerHTML=s(n,e)})}function o(n,e){if("string"==typeof n){var t=document.createElement("code");return t.innerHTML=n,s(t,e)}}function s(n,e){e=e||{singleLine:!1};var t=e.singleLine?0:1;return c(n),a(n.innerHTML,t)}function a(n,e){var t=u(n);if(""===t[t.length-1].trim()&&t.pop(),t.length>e){for(var r="",i=0,l=t.length;i<l;i++)r+=g('<tr><td class="{0}"><div class="{1} {2}" {3}="{5}"></div></td><td class="{4}"><div class="{1}">{6}</div></td></tr>',[j,m,L,b,p,i+1,t[i].length>0?t[i]:" "]);return g('<table class="{0}">{1}</table>',[v,r])}return n}function c(n){var e=n.childNodes;for(var t in e)if(e.hasOwnProperty(t)){var r=e[t];h(r.textContent)>0&&(r.childNodes.length>0?c(r):d(r.parentNode))}}function d(n){var e=n.className;if(/hljs-/.test(e)){for(var t=u(n.innerHTML),r=0,i="";r<t.length;r++){var l=t[r].length>0?t[r]:" ";i+=g('<span class="{0}">{1}</span>\n',[e,l])}n.innerHTML=i.trim()}}function u(n){return 0===n.length?[]:n.split(y)}function h(n){return(n.trim().match(y)||[]).length}function f(e){e()}function g(n,e){return n.replace(/{(\d+)}/g,function(n,t){return e[t]?e[t]:n})}var v="hljs-ln",m="hljs-ln-line",p="hljs-ln-code",j="hljs-ln-numbers",L="hljs-ln-n",b="data-line-number",y=/\r\n|\r|\n/g;n.hljs?(n.hljs.initLineNumbersOnLoad=r,n.hljs.lineNumbersBlock=l,n.hljs.lineNumbersValue=o,t()):n.console.error("highlight.js not detected!")}(window,document);

/**
 * This reveal.js plugin is wrapper around the highlight.js
 * syntax highlighting library.
 */
(function( root, factory ) {
  if (typeof define === 'function' && define.amd) {
    root.RevealHighlight = factory();
  } else if( typeof exports === 'object' ) {
    module.exports = factory();
  } else {
    // Browser globals (root is window)
    root.RevealHighlight = factory();
  }
}( this, function() {

  // Function to perform a better "data-trim" on code snippets
  // Will slice an indentation amount on each line of the snippet (amount based on the line having the lowest indentation length)
  function betterTrim(snippetEl) {
    // Helper functions
    function trimLeft(val) {
      // Adapted from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/Trim#Polyfill
      return val.replace(/^[\s\uFEFF\xA0]+/g, '');
    }
    function trimLineBreaks(input) {
      var lines = input.split('\n');

      // Trim line-breaks from the beginning
      for (var i = 0; i < lines.length; i++) {
        if (lines[i].trim() === '') {
          lines.splice(i--, 1);
        } else break;
      }

      // Trim line-breaks from the end
      for (var i = lines.length-1; i >= 0; i--) {
        if (lines[i].trim() === '') {
          lines.splice(i, 1);
        } else break;
      }

      return lines.join('\n');
    }

    // Main function for betterTrim()
    return (function(snippetEl) {
      var content = trimLineBreaks(snippetEl.innerHTML);
      var lines = content.split('\n');
      // Calculate the minimum amount to remove on each line start of the snippet (can be 0)
      var pad = lines.reduce(function(acc, line) {
        if (line.length > 0 && trimLeft(line).length > 0 && acc > line.length - trimLeft(line).length) {
          return line.length - trimLeft(line).length;
        }
        return acc;
      }, Number.POSITIVE_INFINITY);
      // Slice each line with this amount
      return lines.map(function(line, index) {
        return line.slice(pad);
      })
        .join('\n');
    })(snippetEl);
  }

  var RevealHighlight = {

    HIGHLIGHT_STEP_DELIMITER: '|',
    HIGHLIGHT_LINE_DELIMITER: ',',
    HIGHLIGHT_LINE_RANGE_DELIMITER: '-',

    init: function() {

      // Read the plugin config options and provide fallbacks
      var config = Reveal.getConfig().highlight || {};
      config.highlightOnLoad = typeof config.highlightOnLoad === 'boolean' ? config.highlightOnLoad : true;
      config.escapeHTML = typeof config.escapeHTML === 'boolean' ? config.escapeHTML : true;

      [].slice.call( document.querySelectorAll( '.reveal pre code' ) ).forEach( function( block ) {

        // Trim whitespace if the "data-trim" attribute is present
        if( block.hasAttribute( 'data-trim' ) && typeof block.innerHTML.trim === 'function' ) {
          block.innerHTML = betterTrim( block );
        }

        // Escape HTML tags unless the "data-noescape" attrbute is present
        if( config.escapeHTML && !block.hasAttribute( 'data-noescape' )) {
          block.innerHTML = block.innerHTML.replace( /</g,"&lt;").replace(/>/g, '&gt;' );
        }

        // Re-highlight when focus is lost (for contenteditable code)
        block.addEventListener( 'focusout', function( event ) {
          hljs.highlightBlock( event.currentTarget );
        }, false );

        if( config.highlightOnLoad ) {
          RevealHighlight.highlightBlock( block );
        }
      } );

    },

    /**
     * Highlights a code block. If the <code> node has the
     * 'data-line-numbers' attribute we also generate slide
     * numbers.
     *
     * If the block contains multiple line highlight steps,
     * we clone the block and create a fragment for each step.
     */
    highlightBlock: function( block ) {

      hljs.highlightBlock( block );

      // Don't generate line numbers for empty code blocks
      if( block.innerHTML.trim().length === 0 ) return;

      if( block.hasAttribute( 'data-line-numbers' ) ) {
        hljs.lineNumbersBlock( block, { singleLine: true } );

        // If there is at least one highlight step, generate
        // fragments
        var highlightSteps = RevealHighlight.deserializeHighlightSteps( block.getAttribute( 'data-line-numbers' ) );
        if( highlightSteps.length > 1 ) {

          // If the original code block has a fragment-index,
          // each clone should follow in an incremental sequence
          var fragmentIndex = parseInt( block.getAttribute( 'data-fragment-index' ), 10 );
          if( typeof fragmentIndex !== 'number' || isNaN( fragmentIndex ) ) {
            fragmentIndex = null;
          }

          // Generate fragments for all steps except the original block
          highlightSteps.slice(1).forEach( function( highlight ) {

            var fragmentBlock = block.cloneNode( true );
            fragmentBlock.setAttribute( 'data-line-numbers', RevealHighlight.serializeHighlightSteps( [ highlight ] ) );
            fragmentBlock.classList.add( 'fragment' );
            block.parentNode.appendChild( fragmentBlock );
            RevealHighlight.highlightLines( fragmentBlock );

            if( typeof fragmentIndex === 'number' ) {
              fragmentBlock.setAttribute( 'data-fragment-index', fragmentIndex );
              fragmentIndex += 1;
            }
            else {
              fragmentBlock.removeAttribute( 'data-fragment-index' );
            }

          } );

          block.removeAttribute( 'data-fragment-index' )
          block.setAttribute( 'data-line-numbers', RevealHighlight.serializeHighlightSteps( [ highlightSteps[0] ] ) );

        }

        RevealHighlight.highlightLines( block );

      }

    },

    /**
     * Visually emphasize specific lines within a code block.
     * This only works on blocks with line numbering turned on.
     *
     * @param {HTMLElement} block a <code> block
     * @param {String} [linesToHighlight] The lines that should be
     * highlighted in this format:
     * "1" 		= highlights line 1
     * "2,5"	= highlights lines 2 & 5
     * "2,5-7"	= highlights lines 2, 5, 6 & 7
     */
    highlightLines: function( block, linesToHighlight ) {

      var highlightSteps = RevealHighlight.deserializeHighlightSteps( linesToHighlight || block.getAttribute( 'data-line-numbers' ) );

      if( highlightSteps.length ) {

        highlightSteps[0].forEach( function( highlight ) {

          var elementsToHighlight = [];

          // Highlight a range
          if( typeof highlight.end === 'number' ) {
            elementsToHighlight = [].slice.call( block.querySelectorAll( 'table tr:nth-child(n+'+highlight.start+'):nth-child(-n+'+highlight.end+')' ) );
          }
          // Highlight a single line
          else if( typeof highlight.start === 'number' ) {
            elementsToHighlight = [].slice.call( block.querySelectorAll( 'table tr:nth-child('+highlight.start+')' ) );
          }

          if( elementsToHighlight.length ) {
            elementsToHighlight.forEach( function( lineElement ) {
              lineElement.classList.add( 'highlight-line' );
            } );

            block.classList.add( 'has-highlights' );
          }

        } );

      }

    },

    /**
     * Parses and formats a user-defined string of line
     * numbers to highlight.
     *
     * @example
     * RevealHighlight.deserializeHighlightSteps( '1,2|3,5-10' )
     * // [
     * //   [ { start: 1 }, { start: 2 } ],
     * //   [ { start: 3 }, { start: 5, end: 10 } ]
     * // ]
     */
    deserializeHighlightSteps: function( highlightSteps ) {

      // Remove whitespace
      highlightSteps = highlightSteps.replace( /\s/g, '' );

      // Divide up our line number groups
      highlightSteps = highlightSteps.split( RevealHighlight.HIGHLIGHT_STEP_DELIMITER );

      return highlightSteps.map( function( highlights ) {

        return highlights.split( RevealHighlight.HIGHLIGHT_LINE_DELIMITER ).map( function( highlight ) {

          // Parse valid line numbers
          if( /^[\d-]+$/.test( highlight ) ) {

            highlight = highlight.split( RevealHighlight.HIGHLIGHT_LINE_RANGE_DELIMITER );

            var lineStart = parseInt( highlight[0], 10 ),
              lineEnd = parseInt( highlight[1], 10 );

            if( isNaN( lineEnd ) ) {
              return {
                start: lineStart
              };
            }
            else {
              return {
                start: lineStart,
                end: lineEnd
              };
            }

          }
          // If no line numbers are provided, no code will be highlighted
          else {

            return {};

          }

        } );

      } );

    },

    /**
     * Serializes parsed line number data into a string so
     * that we can store it in the DOM.
     */
    serializeHighlightSteps: function( highlightSteps ) {

      return highlightSteps.map( function( highlights ) {

        return highlights.map( function( highlight ) {

          // Line range
          if( typeof highlight.end === 'number' ) {
            return highlight.start + RevealHighlight.HIGHLIGHT_LINE_RANGE_DELIMITER + highlight.end;
          }
          // Single line
          else if( typeof highlight.start === 'number' ) {
            return highlight.start;
          }
          // All lines
          else {
            return '';
          }

        } ).join( RevealHighlight.HIGHLIGHT_LINE_DELIMITER );

      } ).join( RevealHighlight.HIGHLIGHT_STEP_DELIMITER );

    }

  }

  Reveal.registerPlugin( 'highlight', RevealHighlight );

  return RevealHighlight;

}));
        
hljs.initHighlightingOnLoad();
</script></body></html>